# freeVikings - the "Lost Vikings" clone
# Copyright (C) 2005 Jakub "igneus" Pavlik

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


# sword.rb
# igneus 22.2.2005

# Trida representujici kratky vikinsky mec

require 'rect.rb'

module FreeVikings

  class Sword < Sprite

    def initialize(owner)
      @owner = owner
      @direction = 'right'
      @rect = Rectangle.new 0,0,0,0
      init_images
    end

    def left
      @rect.left
    end

    def top
      @rect.top
    end

    def state
      @owner.state.direction
    end

    def update
      @rect.w = image.w
      @rect.h = image.h

      @rect.top = @owner.top + @owner.rect.h / 2.2

      @rect.left = case @owner.state.direction
                   when 'left'
                     @owner.left - self.rect.w + @owner.rect.w/5
                   when 'right'
                     @owner.left + @owner.rect.w - @owner.rect.w/5
                   end

      stroken = @location.sprites_on_rect(self.rect)
      stroken.delete_if {|s| s == self or not s.is_a? Monster}
      stroken.each do |s|
        s.hurt
      end
    end

    private
    def init_images
      left = Image.new('sword_left.png')
      right = Image.new('sword_right.png')
      @image = ImageBank.new self
      @image.add_pair 'left', left
      @image.add_pair 'right', right
    end
  end # class Sword
end # module FreeVikings
